# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_stduy
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2023/8/7 20:09
# Description:
# 
# ---------------------------------------------------------------------------
import pytest
import allure
import logging

from common.readexcel import ReadExcel


class TestBPM:

    @allure.epic("BPM系统")
    @pytest.mark.parametrize("module, interface, title, level, method, url, mime, data, expect, sqltype, sqlsentence, updatakey",ReadExcel().get_data())
    def test_bpm(self,req_fix, db_fix, module, interface, title, level, method, url, mime, data, expect, sqltype, sqlsentence, updatakey):
        allure.dynamic.feature(module)
        allure.dynamic.story(interface)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)

        if sqltype == "delete":
            db_fix.delete(sqlsentence)

        elif sqltype == "select":
            result2 = db_fix.select(sqlsentence)
            data[updatakey] = result2

        elif sqltype == "delete|select" or sqltype == "select|delete":
            db_fix.delete(sqlsentence["delete"])
            result3 = db_fix.select(sqlsentence["select"])
            data[updatakey] = result3



        results = req_fix.requests_all(req_method=method, req_url=url, req_mime=mime, case_data=data)


        try:
            for key in expect:
                assert expect[key] == results.json().get(key)
        except:
            print("断言失败")
            logging.error("断言失败, 模块名称为：{}，接口名称为：{}，用例标题：{}，用例为：{}，期望结果为：{}，服务器返回数据为：{}".format(module, interface, title, str(data), str(expect), results.text))
            raise AssertionError("断言失败")
        else:
            print("断言成功")

if __name__ == '__main__':
    pytest.main()

